Subject: No identifying value for object of class "" found.
Description

After Upgrade from TYPO3 v6.2.10 to v6.2.11 with Powermail v2.2.0 I get an:

"No identifying value for object of class "" found."

in one powermail form (it's a selectable field with a list of years, see screenshot).

Reverting to TYPO3 v6.2.10 solves the problem temporarly.

Related issues:
related to Core - Bug # 65073: SelectViewHelper doesn't handle optionValueFie... Needs Feedback2015-02-14
related to Core - Bug # 66046: ViewHelper SelectView does not Closed 2015-03-26
duplicated by powermail - Bug # 66048: Select Field only shows: No identifyin... Rejected 2015-03-26

History
#1 - 2015-03-17 18:09 - Alex Kellner
- Status changed from New to Needs Feedback
- Assigned To set to Sandro Barbieri

Hi,

did you clean the caches in Install Tool after upgrading?

Alex

#2 - 2015-03-17 20:48 - Joerg W

I have done the same upgrade and got exactly the same error message with plugin version 2.1.17.

In the log I get:

Core: Error handler (FE): PHP Warning: get_class() expects parameter 1 to be object, array given in
/home_pr1/g/o/gospelchor-winterthur.ch/typo3/typo3_src-6.2.11/typo3/sysext/fluid/Classes/ViewHelpers/Form/SelectViewHelper.php line 174

#3 - 2015-03-18 11:39 - Christoph Lehmann

Same error here. I cleared all caches.
diff typo3_src-6.2.10/typo3/sysext/fluid/Classes/ViewHelpers/Form/SelectViewHelper.php
typo3_src-6.2.11/typo3/sysext/fluid/Classes/ViewHelpers/Form/SelectViewHelper.php
158c158
<             if (is_object($value)) {
---
>             if (is_object($value) || is_array($value)) {

#4 - 2015-03-18 11:46 - Claus Fassing

I fix this for me by setting optionValueField to "value" in Select.html

<vh:Form.SelectField
 options="{field.modifiedSettings}" 
 optionValueField="value" 
 property="{field.marker}" 
 class="powermail_field powermail_select {vh:Validation.ErrorClass(field:field, class:'powermail_field_error')}" 
 id="powermail_field_{field.marker}" 
 additionalAttributes="{vh:Validation.ValidationDataAttribute(field:field)}" 
 multiple="{field.multiselectForField}" 
 value="{vh:Misc.PrefillField(field:field, mail:mail)}" 
/>

For me this looks more to be a bug of the SelectViewHelper as of Powermail.
I don't remember that the optionValueField attribute is a mandatory field.

#5 - 2015-03-18 11:53 - Claus Fassing

Thanks for the diff Christoph.

Looks like options can pass as array now but without a handle for the key assignment.

#6 - 2015-03-18 11:53 - Christoph Lehmann

works - thanks!

#7 - 2015-03-18 17:30 - André Wuttig
- File SelectFieldViewHelper.patch added

Here is my patch which changes the SelectFieldViewHelper to work under 6.2.11 I don´t know if it is the best solutation. Your way is also nice.

#8 - 2015-03-19 11:29 - Urs Braem

Same here. I was unable to apply the Patch by André, as I didn't even find the Select*Field*ViewHelper. 
Changing  if (is_object($value) || is_array($value)) {
 back to if (is_object($value))
 worked

#9 - 2015-03-19 11:32 - Urs Braem

Should and can this be moved to core?

#10 - 2015-03-19 11:52 - Marcus Schwemer

This should be change in the Core, since 6.2.11 introduces a breaking change.

Even post-verifies on gerrit of ACME-members state that it breaks: https://review.typo3.org/#/c/36909/

#11 - 2015-03-19 15:28 - Michael Schwarzenberger

I have the same prolem with 6.2.11 and powermail.
Afert change back to 

if (is_object($value))

it is work for me, but the conditions and form work very slow.

Micha

#12 - 2015-03-19 19:12 - Gerrit Code Review
- Status changed from Needs Feedback to Under Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37959

#13 - 2015-03-20 09:56 - Alex Kellner
- Assigned To changed from Sandro Barbieri to Alex Kellner
- % Done changed from 0 to 60
- Has patch changed from No to Yes

Thx for all that spent time into that issue.
I also reviewed it and came to the solution that this is related to core.
I hope that TYPO3 6.2.12 will include this patch: https://review.typo3.org/#/c/37959/2

Sorry for this discomfort.

I will let this ticket open for all people who are searching for a solution.

#14 - 2015-03-25 14:53 - Stefan Neufeind
Core has merged the patch meanwhile. Just had to try it myself with a pre-6.2.12, which solved the problem. So as soon as 6.2.12 ships, we're fine :-)

#15 - 2015-04-16 11:01 - Alex Kellner
- Status changed from Under Review to Resolved
- % Done changed from 60 to 100

TYPO3 6.2.12 is available now.
This fixes this issue.

Thx to all reporter

Files
Screen Shot 2015-03-17 at 5.45.41 PM.png 39.3 kB 2015-03-17 Sandro Barbieri
SelectFieldViewHelper.patch 1.7 kB 2015-03-18 André Wuttig
